## grass 7.8.7

=== Makefile ===
#############################################################################
#
# MODULE:   	GRASS Compilation
# AUTHOR(S):	Original author unknown - probably CERL
#   	    	Justin Hickey - Thailand - jhickey AT hpcc.nectec.or.th
#   	    	Markus Neteler - Germany - neteler AT itc.it
#   	    	Andreas Lange - Germany - Andreas.Lange AT Rhein-Main.de
#   	    	Radim Blazek - Italy - blazek AT itc.it
# PURPOSE:  	It provides the commands necessary to compile, install,
#   	    	clean, and uninstall GRASS
#   	    	See INSTALL file for explanations.
# COPYRIGHT:    (C) 2002-2012 by the GRASS Development Team
#
#               This program is free software under the GNU General Public
#   	    	License (>=v2). Read the file COPYING that comes with GRASS
#   	    	for details.
#
#############################################################################

MODULE_TOPDIR = .

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Compile.make

DATE := $(shell date '+%d_%m_%Y')

DIRS = \
	demolocation \
	tools \
	include \
	lib \
	db \
	display \
	general \
	raster \
	raster3d \
	vector \
	misc \
	imagery \
	ps \
	scripts \
	temporal \
	doc \
	gui \
	visualization \
	locale \
	man \
	macosx \
	mswindows

SUBDIRS = $(DIRS)

FILES = AUTHORS CHANGES CITING COPYING GPL.TXT INSTALL REQUIREMENTS.html contributors.csv contributors_extra.csv translators.csv
FILES_DST = $(patsubst %,$(ARCH_DISTDIR)/%,$(FILES))

default:
	@echo "GRASS GIS $(GRASS_VERSION_MAJOR).$(GRASS_VERSION_MINOR).$(GRASS_VERSION_RELEASE) $(GRASS_VERSION_GIT) compilation log" \
		> $(ERRORLOG)
	@echo "--------------------------------------------------" >> $(ERRORLOG)
	@echo "Started compilation: `date`"                        >> $(ERRORLOG)
	@echo "--"                                                 >> $(ERRORLOG)
	@echo "Errors in:"                                         >> $(ERRORLOG)
	-$(CHMOD) 755 install-sh
	$(MAKE) subdirs
	$(MAKE) $(FILES_DST)
	$(MAKE) manifests
	@if [ `wc -l < "$(ERRORLOG)"` -gt 5 ] ; then \
		echo "--"     >> $(ERRORLOG) ; \
		echo "In case of errors please change into the directory with error and run 'make'." >> $(ERRORLOG) ; \
		echo "If you get multiple errors, you need to deal with them in the order they"      >> $(ERRORLOG) ; \
		echo "appear in the error log. If you get an error building a library, you will"     >> $(ERRORLOG) ; \
		echo "also get errors from anything which uses the library."  >> $(ERRORLOG) ; \
	else \
		echo "No errors detected." >> $(ERRORLOG) ; \
	fi
	@echo "--"  >> $(ERRORLOG)
	@echo "Finished compilation: `date`" >> $(ERRORLOG)
	@cat $(ERRORLOG)
	@if [ `wc -l < "$(ERRORLOG)"` -gt 8 ] ; then false ; else true ; fi

manifests:
ifeq ($(MANIFEST),external)
	find $(ARCH_DISTDIR) -type f -name '*.exe' | \
	while read file ; do \
	    $(MAKE) "$$file".manifest ; \
	done
endif

$(ARCH_DISTDIR)/%: %
	$(INSTALL_DATA) $< $@

LIBDIRS = \
	lib/external/shapelib \
	lib/datetime \
	lib/gis \
	lib/linkm \
	lib/db \
	lib/vector \
	db/drivers \
	lib/python

# Compile libraries only
libs:
	$(MAKE) -C include
	$(MAKE) subdirs SUBDIRS=$(LIBDIRS)
	$(MAKE) $(FILES_DST)

cleandistdirs: 
	-rm -rf $(ARCH_DISTDIR)
	-rm -rf $(ARCH_BINDIR)

# Clean out the strings extracted from scripts for translation
cleanscriptstrings:
	rm -f locale/scriptstrings/*.c 2>/dev/null

clean: cleandistdirs cleanscriptstrings cleandocs

libsclean: cleandistdirs
	$(MAKE) clean-recursive SUBDIRS=$(LIBDIRS)

distclean: clean
	-rm -f config.cache config.log config.status config.status.$(ARCH) 2>/dev/null
	-rm -f ChangeLog ChangeLog.bak $(ERRORLOG) grass.pc
	-rm -f include/config.h include/version.h
	-rm -f include/Make/Platform.make include/Make/Doxyfile_arch_html include/Make/Doxyfile_arch_latex 2>/dev/null

include $(MODULE_TOPDIR)/include/Make/Install.make
include $(MODULE_TOPDIR)/include/Make/Docs.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make
include $(MODULE_TOPDIR)/include/Make/Sphinx.make

DOXNAME=grass

.PHONY: default libs
.PHONY: cleandistdirs cleanscriptstrings clean libsclean distclean

=== db/Makefile ===

MODULE_TOPDIR = ..

SUBDIRS = \
	db.columns \
	db.connect \
	db.copy \
	db.createdb \
	db.databases \
	db.describe \
	db.drivers \
	db.dropdb \
	db.execute \
	db.login \
	db.select \
	db.tables

CLEAN_SUBDIRS = drivers

PGM = databaseintro

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir:
	$(MAKE) -C drivers
	$(MAKE) parsubdirs

=== demolocation/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

SRCFILES = WIND DEFAULT_WIND VAR PROJ_INFO PROJ_UNITS MYNAME
DBFMAPS = mysites point
SQLITEMAPS = country_boundaries
MAPFILES = dbln coor topo head cidx sidx hist
DBFFILES := $(foreach map,$(DBFMAPS),dbf/$(map).dbf)
SQLITEFILES = sqlite/sqlite.db
VECTFILES := $(foreach map,$(DBFMAPS),$(foreach file,$(MAPFILES),vector/$(map)/$(file))) $(foreach map,$(SQLITEMAPS),$(foreach file,$(MAPFILES),vector/$(map)/$(file)))
SRC := $(SRCFILES) $(DBFFILES) $(SQLITEFILES) $(VECTFILES)
SRCDIRS := PERMANENT PERMANENT/vector PERMANENT/dbf PERMANENT/sqlite $(patsubst %,PERMANENT/vector/%,$(DBFMAPS)) $(patsubst %,PERMANENT/vector/%,$(SQLITEMAPS))

DSTDIR = $(ARCH_DISTDIR)/demolocation
DST := $(patsubst %,$(DSTDIR)/PERMANENT/%,$(SRC))
DSTDIRS := $(patsubst %,$(DSTDIR)/%,$(SRCDIRS))
RCFILE = $(DSTDIR)/.grassrc$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR)

default: $(DST) $(RCFILE)

$(DSTDIR)/PERMANENT/%: PERMANENT/% | $(DSTDIRS)
	$(INSTALL_DATA) $< $@

$(DSTDIRS): %:
	$(MKDIR) $@

$(RCFILE): grassrc.tmpl | $(DSTDIRS)
	sed 's!@GISDBASE@!$(RUN_GISBASE)!' < $< > $@

=== doc/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

FILES := $(wildcard *.html)

default: $(patsubst %,$(HTMLDIR)/%,$(FILES))

=== include/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Vars.make
include $(MODULE_TOPDIR)/include/Make/Rules.make

SRCH := $(wildcard ../include/*.h ../include/defs/*.h ../include/vect/*.h ../include/iostream/*.h)
DSTH := $(patsubst ../include/%.h,$(ARCH_INCDIR)/%.h,$(SRCH))
DSTH_EXTRA = $(ARCH_INCDIR)/copying.h $(ARCH_INCDIR)/citing.h $(ARCH_INCDIR)/confparms.h

SRCMAKE := $(wildcard ../include/Make/*.make)
DSTMAKE := $(patsubst ../include/Make/%.make,$(ARCH_DISTDIR)/include/Make/%.make,$(SRCMAKE))

default: $(DSTH) $(DSTH_EXTRA) $(DSTMAKE)

# cancel rule from Rules.make
$(ARCH_INCDIR)/%.h: %.h

$(ARCH_INCDIR)/defs/%.h: defs/%.h | $(ARCH_INCDIR)/defs
	$(INSTALL_DATA) $< $@

$(ARCH_INCDIR)/vect/%.h: vect/%.h | $(ARCH_INCDIR)/vect
	$(INSTALL_DATA) $< $@

$(ARCH_INCDIR)/iostream/%.h: iostream/%.h | $(ARCH_INCDIR)/iostream
	$(INSTALL_DATA) $< $@

$(ARCH_INCDIR)/%.h: %.h | $(ARCH_INCDIR)
	$(INSTALL_DATA) $< $@

$(ARCH_INCDIR)/defs: | $(ARCH_INCDIR)
	$(MKDIR) $@

$(ARCH_INCDIR)/vect: | $(ARCH_INCDIR)
	$(MKDIR) $@

$(ARCH_INCDIR)/iostream: | $(ARCH_INCDIR)
	$(MKDIR) $@

$(ARCH_DISTDIR)/include/Make/%.make: Make/%.make | $(ARCH_DISTDIR)/include/Make
	$(INSTALL_DATA) $< $@

$(ARCH_DISTDIR)/include/Make:
	$(MKDIR) $@

$(ARCH_INCDIR)/copying.h: $(MODULE_TOPDIR)/COPYING | $(ARCH_INCDIR)
	sed -e 's/^\(.*\)$$/"\1\\n"/' $< > $@

$(ARCH_INCDIR)/citing.h: $(MODULE_TOPDIR)/CITING | $(ARCH_INCDIR)
	sed -e 's/^\(.*\)$$/"\1\\n"/' $< > $@

$(ARCH_INCDIR)/confparms.h: $(MODULE_TOPDIR)/config.status | $(ARCH_INCDIR)
	$< --config | sed "s/'//g" | sed 's/\(.*\)/".\/configure \1"/' > $@

=== man/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

MANPAGES := $(patsubst $(HTMLDIR)/%.html,$(MANDIR)/%.$(MANSECT),$(wildcard $(HTMLDIR)/*.html))

DSTFILES := \
	$(HTMLDIR)/grassdocs.css \
	$(HTMLDIR)/grass_logo.png \
	$(HTMLDIR)/grass_icon.png \
	$(HTMLDIR)/jquery.fixedheadertable.min.js \
	$(HTMLDIR)/parser_standard_options.css \
	$(HTMLDIR)/parser_standard_options.js

categories = \
	d:display \
	db:database \
	g:general \
	i:imagery \
	m:miscellaneous \
	ps:postscript \
	r:raster \
	r3:raster3d \
	t:temporal \
	v:vector

IDXCATS := $(foreach cat,$(categories),$(lastword $(subst :, ,$(cat))))

IDXSRC = full_index index topics keywords graphical_index manual_gallery class_graphical parser_standard_options $(IDXCATS)

INDICES := $(patsubst %,$(HTMLDIR)/%.html,$(IDXSRC))

ALL_HTML := $(wildcard $(HTMLDIR)/*.*.html)

ifneq (@(type sphinx-build2 > /dev/null),)
SPHINXBUILD   = sphinx-build2
endif
ifneq (@(type sphinx-build > /dev/null),)
SPHINXBUILD   = sphinx-build
endif

default: $(DSTFILES)
	@echo "Generating HTML manual pages index (help system)..."
	$(MAKE) $(INDICES)
	$(call build,check)
	$(MAKE) manpages

# This must be a separate target so that evaluation of $(MANPAGES)
# is delayed until the indices have been generated
left := (
right := )
manpages:
	$(MAKE) $(subst $(left),\$(left),$(subst $(right),\$(right),$(MANPAGES)))

.PHONY: manpages

define build
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_$(1).py $(2)
endef

define build_topics
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_topics.py $(HTMLDIR)
endef

define build_keywords
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_keywords.py $(HTMLDIR)
endef

define build_graphical_index
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_graphical_index.py $(HTMLDIR)
endef

define build_manual_gallery
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_manual_gallery.py $(HTMLDIR)
endef

define build_pso
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./parser_standard_options.py -t "$(GRASS_HOME)/lib/gis/parser_standard_options.c" \
	-f "grass" -o "$(HTMLDIR)/parser_standard_options.html" -p 'id="opts_table" class="scroolTable"'
endef

$(HTMLDIR)/topics.html: $(ALL_HTML)

define build_class_graphical
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_class_graphical.py $(HTMLDIR)
endef

$(HTMLDIR)/topics.html: $(ALL_HTML) build_topics.py
	$(call build_topics)
	touch $@

$(HTMLDIR)/full_index.html: $(ALL_HTML) build_full_index.py build_html.py
	$(call build,full_index)
	touch $@

$(HTMLDIR)/index.html: build_index.py build_html.py
	$(call build,index)
	touch $@

$(HTMLDIR)/keywords.html: $(ALL_HTML)
	$(call build_keywords)
	touch $@


$(HTMLDIR)/graphical_index.html: $(ALL_HTML)
	$(call build_graphical_index)
	touch $@

$(HTMLDIR)/manual_gallery.html: $(ALL_HTML)
	$(call build_manual_gallery)

$(HTMLDIR)/parser_standard_options.html: $(ALL_HTML)
	$(call build_pso)
	touch $@

# TODO: this should be done in the same way as category_rule
$(HTMLDIR)/class_graphical.html: $(ALL_HTML)
	$(call build_class_graphical)
	touch $@

define category_rule
$$(HTMLDIR)/$(2).html: $$(wildcard $$(HTMLDIR)/$(1).*.html) build_class.py build_html.py
	$$(call build,class,$(1) $(2))
	touch $$@
endef

$(foreach cat,$(categories),$(eval $(call category_rule,$(firstword $(subst :, ,$(cat))),$(lastword $(subst :, ,$(cat))))))

$(HTMLDIR)/grassdocs.css: grassdocs.css
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_logo.png: grass_logo.png
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_icon.png: grass_icon.png
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/jquery.fixedheadertable.min.js: jquery.fixedheadertable.min.js
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/parser_standard_options.js: parser_standard_options.js
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/parser_standard_options.css: parser_standard_options.css
	$(INSTALL_DATA) $< $@

=== temporal/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	t.connect \
	t.create \
	t.downgrade \
	t.support \
	t.topology \
	t.list \
	t.info \
	t.merge \
	t.remove \
	t.sample \
	t.register \
	t.unregister \
	t.rast.accumulate \
	t.rast.accdetect \
	t.rast.aggregate \
	t.rast.aggregate.ds \
	t.rast.colors \
	t.rast.contour \
	t.rast.to.rast3 \
	t.rast.univar \
	t.rast.list \
	t.rast.mapcalc \
	t.rast.algebra \
	t.rast.neighbors \
	t.rast.series \
	t.rast.export \
	t.rast.out.vtk \
	t.rast.import \
	t.rast.gapfill \
	t.rast.extract \
	t.rast.to.vect \
	t.rast.what \
	t.rast3d.list \
	t.rast3d.extract \
	t.rast3d.mapcalc \
	t.rast3d.algebra \
	t.rast3d.univar \
	t.rename \
	t.select \
	t.snap \
	t.shift \
	t.vect.list \
	t.vect.db.select \
	t.vect.export \
	t.vect.extract \
	t.vect.algebra \
	t.vect.import \
	t.vect.what.strds \
	t.vect.observe.strds \
	t.vect.univar

PGM = temporalintro

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== testsuite/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	raster

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== db/db.connect/Makefile ===

MODULE_TOPDIR = ../..

LIBES = $(DBMILIB) $(GISLIB)
DEPENDENCIES = $(DBMIDEP) $(GISDEP)

PGM = db.connect

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== db/db.tables/Makefile ===

MODULE_TOPDIR = ../..

LIBES = $(DBMILIB) $(GISLIB)
DEPENDENCIES = $(DBMIDEP) $(GISDEP)

PGM = db.tables

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== display/d.barscale/Makefile ===
MODULE_TOPDIR = ../..

PGM = d.barscale

LIBES = $(DISPLAYLIB) $(SYMBLIB) $(GISLIB)
DEPENDENCIES = $(DISPLAYDEP) $(SYMBDEP) $(GISDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

# thumbnail previews
IMGSRC := $(wildcard thumbnails/*.png)
IMGDST := $(patsubst thumbnails/%,$(HTMLDIR)/barscales/%,$(IMGSRC))

default: cmd $(IMGDST)

$(HTMLDIR)/barscales/%.png: thumbnails/%.png | $(HTMLDIR)/barscales
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/barscales: $(HTMLDIR)
	$(MKDIR) $@

=== display/d.geodesic/Makefile ===
MODULE_TOPDIR = ../..

PGM = d.geodesic

LIBES = $(DISPLAYLIB) $(GISLIB)
DEPENDENCIES = $(DISPLAYDEP) $(GISDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== debian/changelog ===
grass (7.8.7-1) unstable; urgency=medium

  * New upstream release.
  * Drop pdal support.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 23 Feb 2022 18:50:44 +0100

grass (7.8.7~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Jan 2022 07:45:47 +0100

grass (7.8.6-1) unstable; urgency=medium

  * New upstream release.
  * Add pkg-config to build dependencies.
  * Drop spelling-errors.patch, applied upstream.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Oct 2021 17:04:24 +0200

grass (7.8.6~rc3-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop autoconf patches, included upstream.
  * Update lintian overrides.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Oct 2021 08:58:18 +0200

grass (7.8.6~rc2-1~exp2) experimental; urgency=medium

  * Bump Standards-Version to 4.6.0, no changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Add upstream patches to fix FTBFS with newer autoconf.
    (closes: #992810)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 16 Sep 2021 06:41:47 +0200

grass (7.8.6~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Add libjs-jquery to grass-doc dependencies.
    (closes: #988928)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 10 Aug 2021 20:09:50 +0200

grass (7.8.6~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Update upstream metadata.
  * Don't set absolute path for INST_DIR, DESTDIR now supported.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 20 May 2021 10:53:36 +0200

grass (7.8.5-2) unstable; urgency=medium

  * Add upstream patch to fix FTBFS with GDAL 3.3.1.
    (closes: #992530)

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Aug 2021 06:44:13 +0200

=== debian/control ===
Source: grass
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: bison,
               debhelper-compat (= 12),
               dh-python,
               doxygen,
               fakeroot,
               flex,
               graphviz,
               libblas-dev,
               libbz2-dev,
               libcairo2-dev,
               libegl1-mesa-dev,
               libfftw3-dev,
               libfreetype6-dev,
               libgdal-dev (>= 2.0),
               libgeos-dev,
               libjpeg-dev,
               liblapack-dev,
               libmotif-dev | lesstif2-dev,
       default-libmysqlclient-dev,
               libncurses5-dev,
               libnetcdf-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libreadline-dev,
               libsqlite3-dev,
               libtiff-dev,
               libwxgtk3.0-gtk3-dev,
               libxmu-dev,
               libzstd-dev,
               lsb-release,
               netcdf-bin,
# install optipng if compressing the PNG images in the programmers' manual
#              optipng,
               pkg-config,
# proj-bin needed for nad2bin during config
               proj-bin,
               python3,
               python3-dev,
               python3-numpy,
               python3-pil,
               python3-ply,
               python3-six,
               python3-wxgtk4.0,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/grass
Vcs-Git: https://salsa.debian.org/debian-gis-team/grass.git
Homepage: https://grass.osgeo.org/

Package: grass
Architecture: all
Section: metapackages
Depends: grass-core,
         grass-gui,
         ${misc:Depends}
Recommends: grass-doc
Suggests: grass-dev
Description: Geographic Resources Analysis Support System (GRASS GIS)
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 Install this virtual package to get a full GRASS system.

Package: grass-core
Architecture: any
Depends: grass-doc,
         python3-distutils,
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Recommends: gdal-bin,
# cs2cs used by m.proj, gdalinfo+gdal_translate used by a number of scripts
            proj-bin
Suggests: grass-dev,
          grass-gui,
# used by v.in.e00
          e00compr,
          avce00,
# used by i.spectral
          gnuplot,
# used by v.in.gpsbabel
          gpsbabel,
# used by v.in.garmin
          gpstrans,
# used by NVIZ, d.out.gpsdrive, r.out.mpeg
          netpbm,
# used by v.kridge
          python3-rpy2,
          python3-six,
          python3-termcolor
Breaks: grass (<< 6.4.2-1~)
Provides: ${grass:Provides}
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS core components
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the core processing components, but not the GUI.

Package: grass-gui
Architecture: any
Depends: grass-core,
# pyGL needed for wxNviz
         python3-opengl,
         python3-wxgtk4.0,
         xterm | x-terminal-emulator,
         ${python3:Depends},
         ${misc:Depends}
Recommends:
# gs needed for wxPsmap PDF export
            ghostscript,
# PIL needed for wxPsmap preview
            python3-matplotlib,
            python3-pil
Breaks: grass (<< 6.4.2-1~)
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS graphical user interfaces
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the GRASS GUIs.

Package: grass-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         ${misc:Depends}
Suggests: grass,
          grass-dev-doc
Description: GRASS GIS user documentation
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains HTML documentation for the GRASS system.

Package: grass-dev-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: grass
Description: GRASS GIS Programmers' Manual
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the HTML version of the GRASS Programmers' Manual.

Package: grass-dev
Section: devel
Architecture: any
Depends: grass-core (= ${binary:Version}),
# fakeroot used by patches/htmlgen-fakeroot; see changelog entry for 5.7.0+6.0.0beta2-2
         fakeroot,
         libfreetype6-dev,
         libgdal-dev,
         libpq-dev,
         libproj-dev,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
# git is needed by g.extension, a primary motivator for installing the grass-dev pkg
Recommends: git,
            subversion
Suggests: grass-dev-doc,
          pkg-config
Description: GRASS GIS development files
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the header files for developing with GRASS.
 Install this package if you wish to develop software that manipulates
 GRASS data sets or install addons using the g.extension module.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Disable PIE on Ubuntu where it's still problematic
VENDOR_DERIVES_FROM_UBUNTU ?= $(shell dpkg-vendor --derives-from Ubuntu && echo yes)
DISTRIBUTION_RELEASE       := $(shell lsb_release -cs)

ifeq ($(VENDOR_DERIVES_FROM_UBUNTU),yes)
  ifneq (,$(filter $(DISTRIBUTION_RELEASE),xenial bionic))
    export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
  endif
endif

VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
GRASS_ABI=grass$(ABI)
BASE_NAME=grass$(VERSION)
PKG_NAME=grass

# TODO: fix these
CFLAGS+=-Wno-error=format-security

CFLAGS+=-Wall

CFLAGS+=-DNDEBUG

TEMPLATES=$(wildcard debian/*.in)

# Use SOURCE_DATE_EPOCH as random seed for reproducible builds
ifdef SOURCE_DATE_EPOCH
	export GRASS_RANDOM_SEED=$(SOURCE_DATE_EPOCH)
endif

versions:
	@echo "Version: $(VERSION)"
	@echo "ABI: $(ABI)"

templates:
	for TEMPLATE in $(TEMPLATES) ; do \
	    sed -e 's/@VERSION@/$(VERSION)/g' -e 's/@ABI@/$(ABI)/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.in$$//'` ; \
	done

%:
	dh $@ --with python3

override_dh_clean:
	dh_clean build-arch-stamp install-arch-stamp debian/grass-gui.image-file-in-usr-lib.list

	$(RM) lib/proj/nad2bin
	$(RM) tools/timer/main.o
	$(RM) raster/r.terraflow/IOStream/lib/src/libiostream.a
	$(RM) debian/$(BASE_NAME).1
	$(RM) error.log

	# clean doxygen documentation (programming man)
	$(RM) doxygen_sqlite3.db lib/doxygen_sqlite3.db
	$(RM) -r \
		doxygenhtml \
		html latex \
		rfc/html rfc/latex \
		lib/html lib/latex \
		gui/wxpython/html gui/wxpython/latex
	for LIBRARY in \
		db \
		g3d \
		gis \
		gmath \
		gpde \
		ogsf \
		proj \
		python \
		segment \
		vector \
		vector/dglib ; \
	do \
		$(RM) -r lib/$$LIBRARY/html lib/$$LIBRARY/latex ; \
	done

override_dh_auto_clean:
	[ ! -f $(CURDIR)/include/Make/Platform.make ] || $(MAKE) distclean

override_dh_auto_configure: templates
	dh_auto_configure -- \
                    --prefix=/usr/lib \
                    --enable-largefile \
                    --enable-socket \
                    --enable-shared \
                    --with-blas \
                    --with-bzlib \
                    --with-cairo \
                    --with-cxx \
                    --with-freetype \
                    --with-freetype-includes=/usr/include/freetype2 \
                    --with-gdal \
                    --with-geos \
                    --with-lapack \
                    --with-motif \
                    --with-mysql \
                    --with-mysql-includes="$(shell mysql_config --include | sed -e 's/-I//g')" \
                    --with-netcdf \
                    --with-nls \
                    --with-odbc \
                    --with-openmp \
                    --with-postgres \
                    --with-postgres-includes=$(shell pg_config --includedir) \
                    --with-proj-share=/usr/share/proj \
                    --with-python \
                    --with-readline \
                    --with-sqlite \
                    --with-wxwidgets=/usr/bin/wx-config \
                    --with-x \
                    --with-zstd

# This target generates arch-dep stuff, unfortunately most doc requires working bins to
# be properly generated...
override_dh_auto_build-arch: build-arch-stamp
build-arch-stamp:
	dh_auto_build
	chmod 755 debian/fixpaths.sh
	touch $@

override_dh_auto_build-indep: build-arch-stamp
	# generate the Programmers' manual (in HTML)
	$(MAKE) htmldocs-single

	# save ~7mb of disk space by compressing PNG images (but takes a long time)
	##for file in `find debian/tmp/programming-manual/ -iname \*.png` ; do \
	##	optipng -o5 $$file ; \
	##done

override_dh_auto_install-arch: install-arch-stamp
install-arch-stamp:
	# install grass core into debian/tmp
	dh_auto_install -- \
		INST_DIR=/usr/lib/$(BASE_NAME) \
		UNIX_BIN=/usr/bin

	# fix links
	debian/fixpaths.sh $(CURDIR)/debian/tmp debian/tmp

	# delete python compiled bytecode files (maybe dh_python2 takes care of this for us?)
	find debian/tmp/ -type f -name "*.pyc" -delete

	# change section from 1 to .1grass
	mv debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/grass7.1 debian/$(BASE_NAME).1
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1; do \
		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/$$n.1grass; done
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/^.TH \(.*\) 1/.TH \1 1grass/' "$$m"; done

	# escape minus signs which are command line options not hyphens
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/\([ ([]\)-\([a-z]\)/\1\\-\2/g' \
			-e 's/\([ []\)--\([a-z]\)/\1\\-\\-\2/g' \
			-e 's/\[-\\fB/[\\-\\fB/' \
			-e 's/\[--\\fB/[\\-\\-\\fB/g' \
			-e 's/"\\fB-\([a-zA-Z0-9]\)/"\\fB\\-\1/' \
			-e 's/"\\fB--\([a-zA-Z0-9]\)/"\\fB\\-\\-\1/' \
			-e 's/\\fI-\([a-zA-Z0-9]\)/\\fI\-\1/g' \
			"$$m"; done

	# adjust from build-server build dir to end-user's install dir
	sed -i -e "s+^\(GRASS_HOME[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		-e "s+^\(RUN_GISBASE[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		debian/tmp/usr/lib/$(BASE_NAME)/include/Make/Platform.make

	# install pkg-config file
	mkdir -p debian/$(PKG_NAME)-dev/usr/share/pkgconfig
	install -m 644 grass.pc debian/$(PKG_NAME)-dev/usr/share/pkgconfig/$(BASE_NAME).pc

	# install icons and desktop file
	mkdir -p debian/tmp/usr/share/icons
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/icons/hicolor debian/tmp/usr/share/icons

	mkdir -p debian/tmp/usr/share/applications
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/applications/grass.desktop debian/tmp/usr/share/applications/$(BASE_NAME).desktop

	# install AppStream metadata
	mkdir -p debian/tmp/usr/share/metainfo
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/metainfo/org.osgeo.grass.appdata.xml debian/tmp/usr/share/metainfo/org.osgeo.grass.appdata.xml

	# install grass wrapper scripts
	install -m 755 debian/x-grass7 debian/tmp/usr/bin/x-$(BASE_NAME)

	ln -fs /usr/lib/$(shell objdump -p /usr/lib/`gdal-config --libs | cut -d' ' -f2 | sed -e 's/-l/lib/'`.so | grep SONAME | cut -d' ' -f18) \
		debian/tmp/usr/lib/$(BASE_NAME)/lib/libgdal.so

	# Remove empty directory
	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/

	# Remove files not installed or installed by debhelper
	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
	         debian/tmp/usr/lib/$(BASE_NAME)/CITING \
	         debian/tmp/usr/lib/$(BASE_NAME)/COPYING \
	         debian/tmp/usr/lib/$(BASE_NAME)/GPL.TXT \
	         debian/tmp/usr/lib/$(BASE_NAME)/INSTALL \
	         debian/tmp/usr/lib/$(BASE_NAME)/REQUIREMENTS.html \
	         debian/tmp/usr/lib/$(BASE_NAME)/config.status \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors_extra.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/demolocation/PERMANENT/.tmp/* \
	         debian/tmp/usr/lib/$(BASE_NAME)/translation_status.json \
	         debian/tmp/usr/lib/$(BASE_NAME)/translators.csv

	# Move image files from /usr/lib/$(BASE_NAME) to /usr/share/$(BASE_NAME)
	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/icons/  debian/tmp/usr/share/$(BASE_NAME)/gui/
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/images/ debian/tmp/usr/share/$(BASE_NAME)/gui/

	find debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/ -type f \( -name "*.jpg" -or -name "*.png" \) -print | sort > debian/grass-gui.image-file-in-usr-lib.list

	while read file; do \
		dir=`dirname "$$file" | sed 's/usr\/lib\//usr\/share\//'` ; \
		if [ ! -e "$$dir" ]; then \
			mkdir -p "$$dir" ; \
		fi ; \
		mv "$$file" "$$dir" ; \
	done < debian/grass-gui.image-file-in-usr-lib.list

	# Remove empty files

## grass 8.2.0

=== man/Makefile ===
--- 
+++ 
@@ -23,6 +23,8 @@
 	r3:raster3d \
 	t:temporal \
 	v:vector
+
+EXTRA_CLEAN_DIRS := $(wildcard __pycache__)
 
 IDXCATS := $(foreach cat,$(categories),$(lastword $(subst :, ,$(cat))))

=== debian/changelog ===
grass (8.2.0-1build1) kinetic; urgency=medium

  * No-change rebuild against libgdal31

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 13 Jun 2022 15:04:24 +0000

grass (8.2.0-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 04 Jun 2022 12:57:48 +0200

grass (8.2.0-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 04 Jun 2022 08:04:27 +0200

grass (8.2.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 25 May 2022 05:36:52 +0200

grass (8.2.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update watch file for GRASS 8.2 releases.
  * Update copyright file.
  * Refresh patches.
  * Update docs files.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 12 May 2022 20:55:50 +0200

grass (8.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop libgdal.so symlink.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 12 May 2022 16:57:19 +0200

grass (8.0.2~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop Ubuntu PIE changes.
  * Update copyright file.
  * Refresh patches.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 26 Apr 2022 22:36:57 +0200

grass (8.0.1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Mar 2022 06:54:02 +0100

grass (8.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update watch file for GRASS 8.0 releases.
  * Update copyright file.
  * Refresh patches.
  * Use usr/bin/grass instead of usr/bin/grass<XY>.
  * Update install files for tools to utils renaming.
  * Update lintian overrides.
  * Simplify dh overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Mar 2022 09:42:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: grass
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
            Bas Couwenberg <sebastic@debian.org>
 Section: science
@@ -34,7 +35,6 @@
                libwxgtk3.0-gtk3-dev,
                libxmu-dev,
                libzstd-dev,
-               lsb-release,
                netcdf-bin,
 # install optipng if compressing the PNG images in the programmers' manual
 #              optipng,

=== debian/rules ===
--- 
+++ 
@@ -5,16 +5,6 @@
 
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
-
-# Disable PIE on Ubuntu where it's still problematic
-VENDOR_DERIVES_FROM_UBUNTU ?= $(shell dpkg-vendor --derives-from Ubuntu && echo yes)
-DISTRIBUTION_RELEASE       := $(shell lsb_release -cs)
-
-ifeq ($(VENDOR_DERIVES_FROM_UBUNTU),yes)
-  ifneq (,$(filter $(DISTRIBUTION_RELEASE),xenial bionic))
-    export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
-  endif
-endif
 
 VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
 ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
@@ -49,10 +39,10 @@
 	dh $@ --with python3
 
 override_dh_clean:
-	dh_clean build-arch-stamp install-arch-stamp debian/grass-gui.image-file-in-usr-lib.list
+	dh_clean debian/grass-gui.image-file-in-usr-lib.list
 
 	$(RM) lib/proj/nad2bin
-	$(RM) tools/timer/main.o
+	$(RM) utils/timer/main.o
 	$(RM) raster/r.terraflow/IOStream/lib/src/libiostream.a
 	$(RM) debian/$(BASE_NAME).1
 	$(RM) error.log
@@ -116,15 +106,10 @@
                     --with-x \
                     --with-zstd
 
-# This target generates arch-dep stuff, unfortunately most doc requires working bins to
-# be properly generated...
-override_dh_auto_build-arch: build-arch-stamp
-build-arch-stamp:
+override_dh_auto_build:
 	dh_auto_build
 	chmod 755 debian/fixpaths.sh
-	touch $@
-
-override_dh_auto_build-indep: build-arch-stamp
+
 	# generate the Programmers' manual (in HTML)
 	$(MAKE) htmldocs-single
 
@@ -133,8 +118,7 @@
 	##	optipng -o5 $$file ; \
 	##done
 
-override_dh_auto_install-arch: install-arch-stamp
-install-arch-stamp:
+override_dh_auto_install:
 	# install grass core into debian/tmp
 	dh_auto_install -- \
 		INST_DIR=/usr/lib/$(BASE_NAME) \
@@ -145,9 +129,9 @@
 
 	# delete python compiled bytecode files (maybe dh_python2 takes care of this for us?)
 	find debian/tmp/ -type f -name "*.pyc" -delete
+	find debian/tmp/ -type d -name "__pycache__" -delete
 
 	# change section from 1 to .1grass
-	mv debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/grass7.1 debian/$(BASE_NAME).1
 	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1; do \
 		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/$$n.1grass; done
 	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
@@ -185,10 +169,7 @@
 	mv debian/tmp/usr/lib/$(BASE_NAME)/share/metainfo/org.osgeo.grass.appdata.xml debian/tmp/usr/share/metainfo/org.osgeo.grass.appdata.xml
 
 	# install grass wrapper scripts
-	install -m 755 debian/x-grass7 debian/tmp/usr/bin/x-$(BASE_NAME)
-
-	ln -fs /usr/lib/$(shell objdump -p /usr/lib/`gdal-config --libs | cut -d' ' -f2 | sed -e 's/-l/lib/'`.so | grep SONAME | cut -d' ' -f18) \
-		debian/tmp/usr/lib/$(BASE_NAME)/lib/libgdal.so
+	install -m 755 debian/x-grass debian/tmp/usr/bin/x-grass
 
 	# Remove empty directory
 	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/
@@ -224,3 +205,28 @@
 	done < debian/grass-gui.image-file-in-usr-lib.list
 
 	# Remove empty files
+	find debian/tmp/ -type f -empty -name "class_graphical*" -print -delete
+
+	install -m 644 -d debian/tmp
+	install -m 644 -d debian/tmp/programming-manual/html
+	cp -r lib/html/* debian/tmp/programming-manual/html/
+	rm -f debian/tmp/programming-manual/html/*.md5
+
+override_dh_install:
+	# Strip binaries
+	strip --strip-unneeded --remove-section=.comment --remove-section=.note debian/tmp/usr/lib/$(BASE_NAME)/bin/r.in.png
+	strip --strip-unneeded --remove-section=.comment --remove-section=.note debian/tmp/usr/lib/$(BASE_NAME)/bin/r.out.png
+
+	dh_install
+
+	# delete duplicated grass-gui stuff from grass-core package
+	for COMPONENT in gui wxpython; do \
+		rm -rf debian/$(PKG_NAME)-core/usr/lib/$(BASE_NAME)/$$COMPONENT; \
+	done
+
+override_dh_installchangelogs:
+	dh_installchangelogs CHANGES
+
+override_dh_python3:
+	dh_python3 -pgrass-core -pgrass-gui -pgrass-dev
+	dh_python3 -pgrass-core /usr/lib/$(BASE_NAME)/etc/
